diff --git a/libiberty/lrealpath.c b/libiberty/lrealpath.c
index 3c7053b0b70..593b51c2d96 100644
--- a/libiberty/lrealpath.c
+++ b/libiberty/lrealpath.c
@@ -36,6 +36,8 @@ components will be simplified.  The returned value will be allocated using
 #include "config.h"
 #include "ansidecl.h"
 #include "libiberty.h"
+#include <malloc.h>
+#include "filenames.h"
 
 #ifdef HAVE_LIMITS_H
 #include <limits.h>
@@ -138,6 +140,32 @@ lrealpath (const char *filename)
   {
     char buf[MAX_PATH];
     char* basename;
+
+    size_t filelen;
+    
+    filelen = strlen (filename) + 1;
+
+    if (filelen > MAX_PATH - 1)
+    {
+	    char * fullpath;
+	    fullpath = (char *) malloc (filelen+8);
+
+	    filelen = strlen (filename)+1;
+	    strcpy(fullpath,"\\\\?\\");
+	    strcat(fullpath,filename);
+
+	    for (int i = 0; fullpath[i]; i++)
+	    {
+		    if (IS_UNIX_DIR_SEPARATOR (fullpath[i]))
+			    fullpath[i] = '\\';
+	    }
+
+	    strcpy(filename,fullpath);
+	    free(fullpath);
+
+	    return (strdup(filename));
+    }
+
     DWORD len = GetFullPathName (filename, MAX_PATH, buf, &basename);
     if (len == 0 || len > MAX_PATH - 1)
       return strdup (filename);
